/*  ,  
        PIND5  PIND6
   ""   10 .
*/
#include <mega8.h>
#include <i2c.h>
#include <delay.h>
//
#define TEA_read  0xC1       //   
#define TEA_write 0xC0       //   
#define min_freq  87
#define max_freq  107.9
#define bt_mute PIND.7       // /
#define BT_PLS PIND.5        // +
#define BT_MIN PIND.6        // -
#define Cathode
#define LED_delay 149      //  

unsigned char data[5];       //    
bit bt_dis;
bit mute;                     // 
bit displ = 1;                //  
int m_displ = 80;             //  
float main_freq = 105.4;      // 
int wr_timer;                 //   
int load = 24;                //   3   
unsigned char bDisplay[4];
unsigned char bCharacter[11] =
{
0x3F, //0
0x06, //1
0x5B, //2
0x4F, //3
0x66, //4
0x6D, //5
0x7D, //6
0x07, //7
0x7F, //8
0x6F, //9
0x00, //blank
};

eeprom float ee_freq;             //  

//=======     ==========
void getPLLWord(float freq)
{
unsigned int freqB;
char freqHi, freqLo;
freqB = 4 * (freq * 1000000 + 225000) / 32768;
freqHi = freqB >> 8;
freqLo = freqB & 0xFF;
data[0] = freqHi;
data[1] = freqLo;
}
//===========================================

//==========    ================
void data_transmit(void)
{
    int i;
    i2c_start();
    i2c_write(TEA_write);
    for (i=0;i<5;i++){
         i2c_write(data[i]);
    }
    i2c_stop();
}


//============    LED ================
 void DisplayData(void)
{
    #ifdef Cathode
        PORTB =bCharacter[bDisplay[0]];
        PORTD.3 = 0;
        delay_us(LED_delay);
        PORTD.3 = 1;

        PORTB =bCharacter[bDisplay[1]] | 0b10000000;
        PORTD.2 = 0;
        delay_us(LED_delay);
        PORTD.2 = 1;

        PORTB =bCharacter[bDisplay[2]];
        PORTD.1 = 0;
        delay_us(LED_delay);
        PORTD.1 = 1;

        PORTB =bCharacter[bDisplay[3]];
        PORTD.0 = 0;
        delay_us(LED_delay);
        PORTD.0 = 1;
    #endif

    #ifdef Anode
        PORTB = ~bCharacter[bDisplay[0]] ;
        PORTD.0 = 1;
        delay_us(LED_delay);
        PORTD.0 = 0;

        PORTB = ~bCharacter[bDisplay[1]] & 0b01111111;
        PORTD.1 = 1;
        delay_us(LED_delay);
        PORTD.1 = 0;

        PORTB = ~bCharacter[bDisplay[2]];
        PORTD.2 = 1;
        delay_us(LED_delay);
        PORTD.2 = 0;

        PORTB = ~bCharacter[bDisplay[3]];
        PORTD.3 = 1;
        delay_us(LED_delay);
        PORTD.3 = 0;
    #endif
}
//=================================================

//===========  0,125  ================
interrupt [TIM0_OVF] void timer0_ovf_isr(void)
{
TCNT0=0x86;
  // 
  if (!bt_dis){
      if (bt_mute){
          if (displ){
              mute ^= 1;
              if (mute){
                   data[0] |= 0x80;
                 }
              else{
                   data[0] &= ~0x80;
                 }
              bt_dis = 1;
              m_displ = 100;
              data_transmit();
              }
          else{
              displ = 1;
              m_displ = 100;
              }
       }

      // +
       if (BT_PLS) {
            bt_dis = 1;
             if (displ){
                 if (main_freq < max_freq){    //  
                     main_freq+=0.1;           //  
                     wr_timer = 240;           // 
                     getPLLWord(main_freq);
                     data_transmit();
                 }
                 m_displ = 100;
             }
             else{
                displ = 1;
                m_displ = 100;
             }
      }
      // -
      if (BT_MIN) {
             bt_dis=1;
             if (displ){
                 if (main_freq > min_freq){  //  
                     main_freq-= 0.1;            //  
                     wr_timer = 240;             // 
                     getPLLWord(main_freq);
                     data_transmit();
                }
                 m_displ = 100;
             }
              else{
                displ = 1;
                m_displ = 100;
             }
      }           

  }  
    if ((!BT_PLS) && (!BT_MIN) && (!bt_mute) && bt_dis==1){bt_dis = 0;}

  // 
  if (wr_timer > 0){
      wr_timer--;
      if ((wr_timer==0) && (ee_freq != main_freq))
      {
         ee_freq = main_freq;
      }
  }
  // 
  if (m_displ>0)
  {
      m_displ--;
      if (m_displ == 0){
         displ = 0;
      }
  }

  // )
  if (load>0){
      load--;
      if (load == 0){
        data[0] &= ~0x80;
        data_transmit();
      }
  }
}


void main(void)
{
// Declare your local variables here
int f;
// Input/Output Ports initialization
// Port B initialization
// Function: Bit7=Out Bit6=Out Bit5=Out Bit4=Out Bit3=Out Bit2=Out Bit1=Out Bit0=Out
DDRB=(1<<DDB7) | (1<<DDB6) | (1<<DDB5) | (1<<DDB4) | (1<<DDB3) | (1<<DDB2) | (1<<DDB1) | (1<<DDB0);
// State: Bit7=0 Bit6=0 Bit5=0 Bit4=0 Bit3=0 Bit2=0 Bit1=0 Bit0=0
PORTB=(0<<PORTB7) | (0<<PORTB6) | (0<<PORTB5) | (0<<PORTB4) | (0<<PORTB3) | (0<<PORTB2) | (0<<PORTB1) | (0<<PORTB0);

// Port C initialization
// Function: Bit6=In Bit5=In Bit4=In Bit3=In Bit2=In Bit1=In Bit0=In
DDRC=(0<<DDC6) | (0<<DDC5) | (0<<DDC4) | (0<<DDC3) | (0<<DDC2) | (0<<DDC1) | (0<<DDC0);
// State: Bit6=T Bit5=T Bit4=T Bit3=T Bit2=T Bit1=T Bit0=T
PORTC=(0<<PORTC6) | (0<<PORTC5) | (0<<PORTC4) | (0<<PORTC3) | (0<<PORTC2) | (0<<PORTC1) | (0<<PORTC0);

// Port D initialization
// Function: Bit7=In Bit6=In Bit5=In Bit4=In Bit3=Out Bit2=Out Bit1=Out Bit0=Out
DDRD=(0<<DDD7) | (0<<DDD6) | (0<<DDD5) | (0<<DDD4) | (1<<DDD3) | (1<<DDD2) | (1<<DDD1) | (1<<DDD0);
// State: Bit7=T Bit6=T Bit5=T Bit4=T Bit3=0 Bit2=0 Bit1=0 Bit0=0
PORTD=(0<<PORTD7) | (0<<PORTD6) | (0<<PORTD5) | (0<<PORTD4) | (0<<PORTD3) | (0<<PORTD2) | (0<<PORTD1) | (0<<PORTD0);

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: 0,977 kHz
TCCR0=(1<<CS02) | (0<<CS01) | (1<<CS00);
TCNT0=0x86;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: Timer1 Stopped
// Mode: Normal top=0xFFFF
// OC1A output: Disconnected
// OC1B output: Disconnected
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer1 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
TCCR1A=(0<<COM1A1) | (0<<COM1A0) | (0<<COM1B1) | (0<<COM1B0) | (0<<WGM11) | (0<<WGM10);
TCCR1B=(0<<ICNC1) | (0<<ICES1) | (0<<WGM13) | (0<<WGM12) | (0<<CS12) | (0<<CS11) | (0<<CS10);
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: Timer2 Stopped
// Mode: Normal top=0xFF
// OC2 output: Disconnected
ASSR=0<<AS2;
TCCR2=(0<<PWM2) | (0<<COM21) | (0<<COM20) | (0<<CTC2) | (0<<CS22) | (0<<CS21) | (0<<CS20);
TCNT2=0x00;
OCR2=0x00;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=(0<<OCIE2) | (0<<TOIE2) | (0<<TICIE1) | (0<<OCIE1A) | (0<<OCIE1B) | (0<<TOIE1) | (1<<TOIE0);


// Bit-Banged I2C Bus initialization
// I2C Port: PORTC
// I2C SDA bit: 0
// I2C SCL bit: 1
// Bit Rate: 100 kHz
// Note: I2C settings are specified in the
// Project|Configure|C Compiler|Libraries|I2C menu.
i2c_init();

// Global enable interrupts
#asm("sei")

//  
if ((ee_freq >= min_freq) && (ee_freq <= max_freq)){
    main_freq = ee_freq;
}
getPLLWord(main_freq);
data[0] |= 0x80;
data[2] = 0x18;
data[3] = 0x10;
data[4] = 0x40;
data_transmit();

while (1)
      {
        f = main_freq * 10;
        bDisplay[0]=f%10;
        bDisplay[1]=f%100/10;
        bDisplay[2]=f%1000/100;
        bDisplay[3]=f/1000;
        if (displ){
            DisplayData();
        }     
        else
        {
            PORTB = 0x00;
        }
      }
}
